//+------------------------------------------------------------------+
//|                                                BS_Stochastic.mq4 |
//|                                        Copyright  2008, masemus |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, masemus"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -0.33
#property indicator_maximum 1.33
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 SlateGray

/*
Price Options
PRICE_CLOSE = 0 Close price. 
PRICE_OPEN = 1 Open price. 
PRICE_HIGH = 2 High price. 
PRICE_LOW = 3 Low price. 
PRICE_MEDIAN = 4 Median price, (high+low)/2. 
PRICE_TYPICAL = 5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED = 6 Weighted close price, (high+low+close+close)/4. 

Ma Options
MODE_SMA = 0 Simple moving average, 
MODE_EMA = 1 Exponential moving average, 
MODE_SMMA = 2 Smoothed moving average, 
MODE_LWMA = 3 Linear weighted moving average. 
Stoch. PriceField: 0-L/H; 1-C/C 

note_TF = "60H1,240H4,1440D1,10080W1,43200MN1";
*/

extern int TimeFrame = 0;
extern int K_period = 5;
extern int D_period = 3;
extern int S_period = 3;
extern int Price = 0;
extern int MA_Method = 0;

double MainBuffer1[];
double MainBuffer2[];
string TimeFrameStr;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   //---- indicator line
   SetIndexBuffer(0,MainBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,MainBuffer2);
   SetIndexStyle(1,DRAW_SECTION);
   
switch(TimeFrame)
   {
      case 1 : TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      default : TimeFrameStr="Current Timeframe"; TimeFrame=0;
   }
  IndicatorShortName("BS_Stochastic ("+K_period+","+D_period+","+S_period+","+TimeFrameStr+")");  

 
//----
   return(0);
  }
   
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
  ObjectsDeleteAll(0,OBJ_LABEL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| MTF Stochastic                                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
  
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
  if (Time[i]<TimeArray[y]) y++; 

  MainBuffer1[i]=0;
  MainBuffer2[i]=0;
   
  double BS_Stochastic;
     
  BS_Stochastic=iStochastic(NULL,TimeFrame,K_period,D_period,S_period,MA_Method,Price,MODE_MAIN,y);

  if (BS_Stochastic>50)MainBuffer1[i]=1;
  if (BS_Stochastic<50)MainBuffer2[i]=1;}
   
  
  
   return(0);
  }
//+------------------------------------------------------------------+